require 'spec_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to specify the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator.  If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails.  There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.
#
# Compared to earlier versions of this generator, there is very limited use of
# stubs and message expectations in this spec.  Stubs are only used when there
# is no simpler way to get a handle on the object needed for the example.
# Message expectations are only used when there is no simpler way to specify
# that an instance is receiving a specific message.

describe SeminationsController do

  # This should return the minimal set of attributes required to create a valid
  # Semination. As you add validations to Semination, be sure to
  # update the return value of this method accordingly.
  def valid_attributes
    {}
  end

  describe "GET index" do
    it "assigns all seminations as @seminations" do
      semination = Semination.create! valid_attributes
      get :index
      assigns(:seminations).should eq([semination])
    end
  end

  describe "GET show" do
    it "assigns the requested semination as @semination" do
      semination = Semination.create! valid_attributes
      get :show, :id => semination.id.to_s
      assigns(:semination).should eq(semination)
    end
  end

  describe "GET new" do
    it "assigns a new semination as @semination" do
      get :new
      assigns(:semination).should be_a_new(Semination)
    end
  end

  describe "GET edit" do
    it "assigns the requested semination as @semination" do
      semination = Semination.create! valid_attributes
      get :edit, :id => semination.id.to_s
      assigns(:semination).should eq(semination)
    end
  end

  describe "POST create" do
    describe "with valid params" do
      it "creates a new Semination" do
        expect {
          post :create, :semination => valid_attributes
        }.to change(Semination, :count).by(1)
      end

      it "assigns a newly created semination as @semination" do
        post :create, :semination => valid_attributes
        assigns(:semination).should be_a(Semination)
        assigns(:semination).should be_persisted
      end

      it "redirects to the created semination" do
        post :create, :semination => valid_attributes
        response.should redirect_to(Semination.last)
      end
    end

    describe "with invalid params" do
      it "assigns a newly created but unsaved semination as @semination" do
        # Trigger the behavior that occurs when invalid params are submitted
        Semination.any_instance.stub(:save).and_return(false)
        post :create, :semination => {}
        assigns(:semination).should be_a_new(Semination)
      end

      it "re-renders the 'new' template" do
        # Trigger the behavior that occurs when invalid params are submitted
        Semination.any_instance.stub(:save).and_return(false)
        post :create, :semination => {}
        response.should render_template("new")
      end
    end
  end

  describe "PUT update" do
    describe "with valid params" do
      it "updates the requested semination" do
        semination = Semination.create! valid_attributes
        # Assuming there are no other seminations in the database, this
        # specifies that the Semination created on the previous line
        # receives the :update_attributes message with whatever params are
        # submitted in the request.
        Semination.any_instance.should_receive(:update_attributes).with({'these' => 'params'})
        put :update, :id => semination.id, :semination => {'these' => 'params'}
      end

      it "assigns the requested semination as @semination" do
        semination = Semination.create! valid_attributes
        put :update, :id => semination.id, :semination => valid_attributes
        assigns(:semination).should eq(semination)
      end

      it "redirects to the semination" do
        semination = Semination.create! valid_attributes
        put :update, :id => semination.id, :semination => valid_attributes
        response.should redirect_to(semination)
      end
    end

    describe "with invalid params" do
      it "assigns the semination as @semination" do
        semination = Semination.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        Semination.any_instance.stub(:save).and_return(false)
        put :update, :id => semination.id.to_s, :semination => {}
        assigns(:semination).should eq(semination)
      end

      it "re-renders the 'edit' template" do
        semination = Semination.create! valid_attributes
        # Trigger the behavior that occurs when invalid params are submitted
        Semination.any_instance.stub(:save).and_return(false)
        put :update, :id => semination.id.to_s, :semination => {}
        response.should render_template("edit")
      end
    end
  end

  describe "DELETE destroy" do
    it "destroys the requested semination" do
      semination = Semination.create! valid_attributes
      expect {
        delete :destroy, :id => semination.id.to_s
      }.to change(Semination, :count).by(-1)
    end

    it "redirects to the seminations list" do
      semination = Semination.create! valid_attributes
      delete :destroy, :id => semination.id.to_s
      response.should redirect_to(seminations_url)
    end
  end

end
